r=input('Giunti elastici? (s/n) ','s');

%Momenti di inerzia motori
Jm1=5.e-3;
Jm2=2.e-3;

%Rapporti di trasmissione
n1=100;
n2=100;
N=diag([n1,n2]);

%Definizione robot

L1=link([0,1,0,0,0]);
L1.m=50;
L1.r=[-0.5,0,0];
L1.I=[0,0,0;0,0,0;0,0,10];
L1.G=n1;
L1.Jm=Jm1;

L2=L1;
L2.G=n2;
L2.Jm=Jm2;

r2=robot({L1,L2});

r2.name='POLIrobot';
r2.gravity=[0,9.81,0];


%Istante iniziale traiettoria
t0=0.1;

%Durata traiettoria
T=0.5;

%Velocit massima
sd=5;

%Distanza da percorrere
h=1.6;

%Tempo di accelerazione
ta=(T*sd-h)/sd;

%Accelerazione massima
amax=sd/ta;

%Valore iniziale traiettoria
s0=0.2;

%Posizione iniziale robot
q0=ikine(r2,[eye(3),[0.2;0;0];[0,0,0,1]],[-1,3],[1 1 0 0 0 0 ]);

%Pulsazione naturale e smorzamanto loop nominali
wn=100;
csi=0.7;

%Guadagni proporzionali e derivativi
KP=wn^2;
KD=2*csi*wn;

%Caso giunti elastici

if r=='s',
 %Ridefinizione robot
  L1.Jm=0;
  L2.Jm=0;
  r2=robot({L1,L2});
  r2.name='POLIrobot';
  r2.gravity=[0,9.81,0];

  %Costanti elastiche trasmissioni
  Kel1=70;
  Kel2=70;
  Kel=diag([Kel1,Kel2]);

  %Coefficienti di attrito viscoso trasmissioni
  Del1=0.05;
  Del2=0.05;
  
  %Riferimento posizione iniziale robot
  qrif0=ikine(r2,[eye(3),[0.2;0;0];[0,0,0,1]],[-1,3],[1 1 0 0 0 0 ]);

  %Posizione iniziale motori
  qm0=qrif0*N;

  %Posizione iniziale link
  q0=fsolve(@(q0) N*Kel*(qm0'-N*q0')-gravload(r2,q0)',qrif0);

end
    